import { types } from "mobx-state-tree";
var Type;
import { mappings } from "../Common";
export function createType() {
    if (!Type) {
        Type = types.union(function (snapshot) {
            return snapshot && typeof snapshot === "object" && "type" in snapshot
                ? mappings[snapshot.type]
                : mappings.null;
        }, mappings.string, mappings.number, mappings.boolean, mappings.null, mappings.object, mappings.array);
    }
    return Type;
}
// Required for Mapping to work
import "../String";
import "../Number";
import "../Boolean";
import "../Null";
import "../Object";
import "../Array";
//# sourceMappingURL=Type.js.map