"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_state_tree_1 = require("mobx-state-tree");
var Type;
var Common_1 = require("../Common");
function createType() {
    if (!Type) {
        Type = mobx_state_tree_1.types.union(function (snapshot) {
            return snapshot && typeof snapshot === "object" && "type" in snapshot
                ? Common_1.mappings[snapshot.type]
                : Common_1.mappings.null;
        }, Common_1.mappings.string, Common_1.mappings.number, Common_1.mappings.boolean, Common_1.mappings.null, Common_1.mappings.object, Common_1.mappings.array);
    }
    return Type;
}
exports.createType = createType;
// Required for Mapping to work
require("../String");
require("../Number");
require("../Boolean");
require("../Null");
require("../Object");
require("../Array");
//# sourceMappingURL=Type.js.map