export declare const formats: {
    alpha: RegExp;
    alphanumeric: RegExp;
    color: RegExp;
    date: RegExp;
    "date-time": RegExp;
    email: RegExp;
    hexadecimal: RegExp;
    "host-name": RegExp;
    hostname: RegExp;
    identifier: RegExp;
    "ip-address": RegExp;
    ipv4: RegExp;
    ipv6: RegExp;
    "json-pointer": RegExp;
    "json-pointer-uri-fragment": RegExp;
    numeric: RegExp;
    phone: RegExp;
    "relative-json-pointer": RegExp;
    style: RegExp;
    time: RegExp;
    uri: RegExp;
    "uri-reference": RegExp;
    "uri-template": RegExp;
    url: RegExp;
    uuid: RegExp;
};
export declare type IMatcher = (value: string) => boolean;
export interface IMatchers {
    [key: string]: IMatcher;
}
export declare const matchers: IMatchers;
